/* Emperor - an X windows strategy game for 1-6 players
   Copyright (C) 1998 Frank Rustemeyer.
   This file is part of the Emperor package.

   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License as
   published by the Free Software Foundation; either version 2 of the
   License, or (at your option) any later version.

   This program is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330, Boston,
   MA 02111-1307, USA.

   If you have changes and you want them to be included in a future
   release of Emperor, please e-mail them to mambres@mud.tap.de.

   This file implements the dialog windows.

   98/11/30, Frank Rustemeyer <mambres@mud.tap.de>: Released.
   99/01/29, Frank Rustemeyer <mambres@mud.tap.de>: Added language support.
*/

#include <xview/xview.h>

#include <stdio.h> // debugging only

#include <string.h>
// strcpy in setupdlg::button_pressed()

#include "emp.h"
#include "empx.h"
#include "empgame.h"
#include "../xvcl/xvcl.h"
#include "text.h"

#include "flag1.xpm"
#include "flag2.xpm"
#include "flag3.xpm"
#include "flag4.xpm"
#include "flag5.xpm"
#include "flag6.xpm"

extern distributor * d;  // object that distributes windows messages
extern game *g;

// ****************************************************** unloadwndw *****

unloadwndw::unloadwndw(window *o, transporter *t)
{   unit *u;

    owner = o;
    create_frame(120,250, T_FERRY);
    set_min_size(120,250);
    set_max_size(120,250);
    pan = new panel(this);
    okbutton = new button(pan, "OK");
    ladung = new listbox(pan, NULL, 10); 
    ladung->set_pos(10,30);

    u = (unit *) FIRSTMEMBER(g->units);
    if (!u) return;
    while (u)
    {   if (u->getcarried() == t->getlfdnr())
           ladung -> add_string(u->name());
// (void *) u, (u->getlfdnr() == t->getnextunload()));
        u = (unit *) u->next();
        }
    }

unloadwndw::~unloadwndw(void)
{   delete ladung;
    delete okbutton;
    delete pan;
    }

//           transp->setnextunload(((unit *) lb->getitem())->getlfdnr());

void unloadwndw::button_pressed(Xv_object item)
{   enddialog(1);
    }
 
// ****************************************************** setupwndw ******

setupwndw::setupwndw() : dialog() 
{   int i;

    create_frame( 600, 315, "Emperor: Setup");

    pan = new panel(this);

    d->addwindow(this, get_handle());
  
    okbutton = new button(pan, "OK");
//    netbutton = new button(pan, T_NETWORK);

    flagge[0] = new imageview(pan, flag1);
    flagge[0] -> set_pos(10, 43);
    flagge[1] = new imageview(pan, flag2);
    flagge[1] -> set_pos(10, 83);
    flagge[2] = new imageview(pan, flag3);
    flagge[2] -> set_pos(10, 123);
    flagge[3] = new imageview(pan, flag4);
    flagge[3] -> set_pos(10, 163);
    flagge[4] = new imageview(pan, flag5);
    flagge[4] -> set_pos(10, 203);
    flagge[5] = new imageview(pan, flag6);
    flagge[5] -> set_pos(10, 243);

    for (i = 0; i < 6; i++)
    {   playerbox[i] = new checkbox(pan, T_PLAYING, g->sp[i+1].used);
        playerbox[i]->set_pos(45, 37 + 40*i);
        compbox[i] = new checkbox(pan, T_COMPUTER, g->sp[i+1].computer);
        compbox[i]->set_pos(145, 37 + 40*i);
        playername[i] = new textbox(pan, T_NAME, g->sp[i+1].name, 40);
        playername[i]->set_pos(245, 40 + 40*i);
        }

    window_fit(get_handle());
    }

setupwndw::~setupwndw()
{   int i;
    
    delete okbutton;
//    delete netbutton;
    for (i = 0; i < 6; i++)
    {   delete playerbox[i];
        delete compbox[i];
        delete playername[i];
        }
    delete pan;
    }
     
void setupwndw::button_pressed(Xv_object button) 
{   int i, players;
    messagebox *mb;
    netwndw *net;
 
    if (button == okbutton->get_handle())
    {   players = 0;
        for( i = 0; i < 6; i++)
        {   g->sp[i+1].used = playerbox[i]->query_value();
            if (g->sp[i+1].used && !(g->sp[i+1].ext)) players++;
            g->sp[i+1].computer = compbox[i]->query_value(); 
            strcpy(g->sp[i+1].name, playername[i]->query_value());
            } 
        if (!players)
        {   mb = new messagebox(this, T_NOPLAYERS);
            delete mb;
            return;
            } 
        enddialog(1);
        return;
        }
  
    // netbutton:
/*  for( i = 0; i < 6; i++)
       strcpy(g->sp[i+1].name, playername[i]->query_value());

    net = new netwndw;
    net->run();
    delete net;
*/
    }

void setupwndw::checkbox_selected(Xv_object cbox, int value)
{   int i;
    for ( i = 0; i < 6; i++)
    {   if (value && (cbox == compbox[i] -> get_handle()))
           playerbox[i]->set_value(1);
        if (!value && (cbox == playerbox[i] -> get_handle()))
           compbox[i]->set_value(0);
        } 
    }

// ****************************************************** netwndw ******

netwndw::netwndw() : dialog()
{   int i;
    char text[60];

    create_frame( 300, 280, T_NETWORKSETUP);

    pan = new panel(this);

    d->addwindow(this, get_handle());
  
    okbutton = new button(pan, "OK");

    for (i = 0; i < 6; i++)
    {   sprintf(text, T_EXTERNAL, g->sp[i+1].name);
        netbox[i] = new checkbox(pan, text, g->sp[i+1].ext);
        netbox[i]->set_pos(10, 37 + 40*i);
        }

    window_fit(get_handle());
    }

netwndw::~netwndw(void)
{   int i;
 
    delete okbutton;
    for (i = 0; i < 6; i++)
       delete netbox[i];
    delete pan;
    }

void netwndw::button_pressed(Xv_object button)
{   int i;
    for (i = 0; i < 6; i++)
        g->sp[i+1].ext = netbox[i]->query_value();
    enddialog(1);
    } 
